/*
// shatbox (C) 2002 Matthew Conte (matt@conte.com)
**
**
** map011.cpp
**
** mapper 11 implementation
**
** $Id: $
*/

#include "mmc/map011.h"


void map011::write(uint32 /*offset*/, uint8 value)
{
   prgbank(32, 0x8000, value & 0xf);
   chrbank(8, 0x0000, value >> 4);
}


void map011::dispatchWrite(void *userdata, uint32 offset, uint8 value)
{
   ((map011 *) userdata)->write(offset, value);
}


static nes6502_memwrite map011_memwrite[] = 
{
   { 0x8000, 0xffff, map011::dispatchWrite, NULL },
   { (uint32) -1, (uint32) -1, NULL, NULL }
};


map011::map011(machine *pMachine, mapperInfo *pInfo)
: mmc(pMachine, pInfo)
{
   mpName = "Color Dreams";
   mpMemWrite = map011_memwrite;
};


void map011::reset(bool hard_reset)
{
   mmc::reset(hard_reset);

   //prgbank(32, 0x8000, 0);
   //chrbank(8, 0x0000, 0);
   write(0, 0);
}
