//
// win32.h
//
// win32 system class
//
// Copyright (C) 2002 Matthew Conte
//
// $Id: $
//

#ifndef _WIN32_H_
#define _WIN32_H_

#include "system.h"
#include "SDL.h"

class win32 : public System
{
public:
   win32();
   virtual ~win32();

   virtual void setColor(int index, int r, int g, int b, int value);
   virtual void lockVideo();
   virtual void unlockVideo();

   virtual int timerResolution() const;

   virtual int pollEvents(eventHandler *pEventHandler);

   virtual void mark();
   virtual int elapsed();
   virtual void usleep(int us);

protected:
   static void audioCallbackDispatch(void *pUserData, Uint8 *pStream, int numSamples);

   int   openVideo();
   void  openAudio();

   void  closeVideo();
   void  closeAudio();

   SDL_Surface *mpScreen;
   bool        mFullScreen;
};

inline int win32::timerResolution() const
{
   return TIMER_RESOLUTION * 1000; // SDL_timer.h tells me so.
}

#endif // !_WIN32_H_
